C_RED    equ    $f800           ;; 100% true (F8 = 11111 5 BITS)
C_GREEN  equ    $07c0           ;; 100% true (11111 5 BITS)
C_BLUE   equ    $003f           ;; 100% true (11111 5 BITS)
C_WHITE  equ    $ffff           ;; LSBit is unused
null    equ     $0
Rzero   equ     $0
AT      equ     $1
V0      equ     $2
V1      equ     $3
A0      equ     $4
A1      equ     $5
A2      equ     $6
A3      equ     $7
T0      equ     $8
T1      equ     $9
T2      equ     $a
T3      equ     $b
T4      equ     $c
T5      equ     $d
T6      equ     $e
T7      equ     $f
S0      equ     $10

GP      equ     28              ; 0x1c General Purpose
SP      equ     29              ; Stack Pointer
RA      equ     31

Index   equ     $0                      ; Cop0 Regs
Random  equ     $1
Count   equ     $9

dw       arg_ptr
dw       arg_w
dw       arg_x
dw       arg_y
dw       arg_z
dw       arg_fx
dw       arg_fy
dw       arg_c
dw       arg_1
dw       arg_2
dw       arg_3
dw       arg_4

dw       arg_for
dw       arg_to

dw       ret_1
dw       ret_2
dw       ret_3
dw       ret_4
dw       ret_data

dw       store1
dw       store2
dw       store3
dw       store4

dw       pcx_y

dw       voc_bit
dw       voc_dac
  
dw      joy.left
dw      joy.right
dw      joy.up
dw      joy.down
dw      joy.byte1
dw      joy.byte2

dw      si_status

.SUB                                    ; Means Compile program as a Sub program (DEFAULT:.SUB)


;- conversion checking function
PROC    4xalign
        push    T0
        nop
        move    T0,ret_1        ;; T0 = ret_1
        ;move    ret_1,T0        ;; ret_1 = T0
        srl     T0,T0,8
        move    ret_2,T0        ;; ret_2 = T0
        srl     T0,T0,8
        move    ret_3,T0        ;; ret_3 = T0
        srl     T0,T0,8
        move    ret_4,T0        ;; ret_4 = T0
        nop
        pop     T0
        retf
        nop
        nop

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

PROC     ASM_PIXEL                          ; <--- Special Defined!!
         PUSH    RA
         PUSH    A0
         PUSH    A1
         PUSH    T5
         PUSH    T6
         PUSH    T7


         MOVE    T6,arg_y
         ;nop
         MOVE    T7,arg_x
         ;nop
         MOVE    T5,arg_c
         ;nop
                  
         addiu    A0,T6,0               ; A0 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A0,A0,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A0,A0,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))


         ;lui     A1,$8010                ; look at N64's Data tables
         ;addiu  A1,A1,8
         movea  A1,vscr0

         ;lw      A1,$0(A1)               ; store vid address in A1
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A0                ; A1+=A0
         sh      T5, $0(A1)              ; BLAST THE 16-BIT VAL


         POP     T7
         POP     T6
         POP     T5
         POP     A1
         POP     A0
         POP     RA
         RETF                            ; JR           R31  (ra)
         nop
         nop


PROC     ASM_HLINE                          ; Draws a horizontal line arg_z in length
         PUSH    RA
         PUSH    A0
         PUSH    A1
         PUSH    T5
         PUSH    T6
         PUSH    T7
               


         MOVE    T6,arg_y
         ;nop
         MOVE    T7,arg_x
         ;nop
         MOVE    T5,arg_c
         ;nop
                  
         addiu    A0,T6,0               ; A0 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A0,A0,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A0,A0,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))


         ;lui     A1,$8010                ; look at N64's Data tables
         ;addiu  A1,A1,8
         movea  A1,vscr0

         ;lw      A1,$0(A1)               ; store vid address in A1
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A0                ; A1+=A0

         addiu   T7,Rzero,1             ; T7 = 1;
         move    T6,arg_z               ; T6 = arg_z; (length)
         nop
HLINE_loop:
         nop
         sh      T5, $0(A1)              ; BLAST THE 16-BIT VAL
         addiu   A1,A1,2                 ; Move pixel up by 1

         sub     T6,T6,T7               ; T6--;
         nop

         bne     Rzero,T6,HLINE_loop
         nop

         POP     T7
         POP     T6
         POP     T5
         POP     A1
         POP     A0
         POP     RA
         RETF                            ; JR           R31  (ra)
         nop
         nop



PROC     ASM_HDATA                          ; Draws a horizontal line arg_z in length
         PUSH    RA
         PUSH    A0
         PUSH    A1
         PUSH    A2
         PUSH    T5
         PUSH    T6
         PUSH    T7
               


         MOVE    T6,arg_y
         ;nop
         MOVE    T7,arg_x
         ;nop
                  
         addiu    A0,T6,0               ; A0 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A0,A0,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A0,A0,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))


         ;lui     A1,$8010                ; look at N64's Data tables
         ;addiu  A1,A1,8
         movea  A1,vscr0                 ;;
         movea  A2,vscr1                 ;;
         ;lw      A1,$0(A1)               ; store vid address in A1
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A0                ; A1+=A0
         add     A2,A2,A0                ; A2+=A0 (same but different vscr page)

         addiu   T7,Rzero,1             ; T7 = 1;
         move    T6,arg_z               ; T6 = arg_z; (length)
         nop
HDATA_loop:
         nop
         lh      T5,$0(A2)
         sh      T5,$0(A1)              ; BLAST THE 16-BIT VAL
         addiu   A1,A1,2                ; Move pixel up by 1
         addiu   A2,A2,2                ; Move data-pixel up by 1
         sub     T6,T6,T7               ; T6--;
         nop

         bne     Rzero,T6,HDATA_loop
         nop

         POP     T7
         POP     T6
         POP     T5
         POP     A2
         POP     A1
         POP     A0
         POP     RA
         RETF                            ; JR           R31  (ra)
         nop
         nop




PROC    ASM_FONTNB
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2
        PUSH    T0
        PUSH    T1
        PUSH    T2
        PUSH    T3
        PUSH    T6
        PUSH    T7

        ; --- Point to Correct image part!
        MOVEA   A0,img_dat           ; Pixels (+32)
        addiu   A0,A0,32

        MOVE    A1,arg_z             ; arg_z contains the Character
        ;addiu   A1,Rzero,99             ;; :->
        sll     A1,A1,5              ; *=5  <<=5
        add     A0,A0,A1             ; a0+=a1
        ; --- point to correct Screen offset!!
         MOVE     T6,arg_y
         ;nop
         MOVE     T7,arg_x
         ;nop
         addiu    A2,T6,0               ; A2 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A2,A2,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A2,A2,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
         ;lui     A1,$8010                ; look at N64's Data tables
         ;addiu  A1,A1,8
         movea   A1,vscr0                ; to vid buffer #0
         ;lw      A1,$0(A1)               ; store vid address in A1
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A2                ; A1+=A0
                        
        ;addiu   A1, A1,6420

        ; --- point to Colours position!!!        
        ;MOVEA   A2,img_dat           ; Colours (+0)
        MOVE    A2,arg_c                ; Specific colour
        addiu   T3, Rzero,1

NextLine:             
        addiu   T2, Rzero,8             ; 8 lines
NextPix:              
        addiu   T1, Rzero,4             ; (4*2) line

        lb      T0, $0(A0)
        andi    T0, T0,$00f0
        srl     T0, T0,4
        add     T0, T0,T0

        ;addu    A3, A2,T0               ;; T0 = A2[T0]
        ;lh      T0, $0(A3)              ;; ""   ""
        beq      T0,Rzero,Black          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                 ; T0 = A2 (Colour)
;Black:
        nop
        sh      T0, $0(A1)
        nop
Black:
        nop
        addiu   A1, A1,2
        
        lb      T0, $0(A0)
        andi    T0, T0,$0f
        add     T0, T0,T0

        ;addu    A3, A2,T0
        ;lh      T0, $0(A3)
        beq      T0,Rzero,Black2          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                  ;  T0 = A2 (Colour)
;Black2:                                  
        nop
        sh      T0, $0(A1)
        nop
Black2:
        nop
        addiu   A1, A1,2

        addiu   A0, A0,1
        sub     T1, T1,T3
        bne     T1, Rzero, NextPix
        nop

        addiu   A1, A1,624                         ; (320-8)*2=624
        sub     T2, T2,T3
        bne     T2, Rzero, NextLine
        nop


        POP     T7
        POP     T6
        POP     T3
        POP     T2
        POP     T1
        POP     T0
        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop




PROC    ASM_FONT
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2
        PUSH    T0
        PUSH    T1
        PUSH    T2
        PUSH    T3
        PUSH    T6
        PUSH    T7

        ; --- Point to Correct image part!
        MOVEA   A0,img_dat           ; Pixels (+32)
        addiu   A0,A0,32

        MOVE    A1,arg_z             ; arg_z contains the Character
        sll     A1,A1,5              ; *=5  <<=5
        add     A0,A0,A1             ; a0+=a1
        ; --- point to correct Screen offset!!
         MOVE     T6,arg_y
         ;nop
         MOVE     T7,arg_x
         ;nop
         addiu    A2,T6,0               ; A2 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A2,A2,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A2,A2,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
         ;lui     A1,$8010                ; look at N64's Data tables
         ;ori     A1,A1,8
         movea   A1,vscr0                ; to vid buffer #0
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A2                ; A1+=A0
                        
        ;addiu   A1, A1,6420

        ; --- point to Colours position!!!        
        ;MOVEA   A2,img_dat           ; Colours (+0)
        MOVE    A2,arg_c                ; Specific colour
        addiu   T3, Rzero,1

ANextLine:             
        addiu   T2, Rzero,8             ; 8 lines
ANextPix:              
        addiu   T1, Rzero,4             ; (4*2) line

        lb      T0, $0(A0)
        andi    T0, T0,$00f0
        srl     T0, T0,4
        add     T0, T0,T0

        ;addu    A3, A2,T0               ;; T0 = A2[T0]
        ;lh      T0, $0(A3)              ;; ""   ""
        beq      T0,Rzero,ABlack          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                 ; T0 = A2 (Colour)
ABlack:
        nop
        sh      T0, $0(A1)
        nop
;ABlack:
        nop
        addiu   A1, A1,2
        
        lb      T0, $0(A0)
        andi    T0, T0,$0f
        add     T0, T0,T0

        ;addu    A3, A2,T0
        ;lh      T0, $0(A3)
        beq      T0,Rzero,ABlack2          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                  ;  T0 = A2 (Colour)
ABlack2:                                  
        nop
        sh      T0, $0(A1)
        nop
;ABlack2:
        nop
        addiu   A1, A1,2

        addiu   A0, A0,1
        sub     T1, T1,T3
        bne     T1, Rzero, ANextPix
        nop

        addiu   A1, A1,624                         ; (320-8)*2=624
        sub     T2, T2,T3
        bne     T2, Rzero, ANextLine
        nop


        POP     T7
        POP     T6
        POP     T3
        POP     T2
        POP     T1
        POP     T0
        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop







PROC    ASM_NUM_FONT
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2

        MOVE    A1,arg_z                ; Get  # for quick access & prevent damaging it!
        andi    A1,A1,$ff               ; Eradicate upperbits

        ; 3rdS.F

        addiu   A0,A1,0
        srl     A0,A0,4
        addiu   A0,A0,$30               ; CHR$(3 + 48) = '3'
        addiu   A2,Rzero,58             
        sub     A0,A0,A2
        bltz    A0,doit3
        nop
        addiu   A0,A0,7
doit3:
        nop
        addiu   A0,A0,58
        MOVE    arg_z,A0
        nop
        CALL    ASM_FONT
        nop
        ; 4thS.F

        addiu   A0,A1,0
        andi    A0,A0,$0f               ; A0 = 0x35 & 0x0f = 0x05
        addiu   A0,A0,$30               ; CHR$(5 + 48) = '5'
        addiu   A2,Rzero,58             
        sub     A0,A0,A2
        bltz    A0,doit4
        nop
        addiu   A0,A0,7
doit4:
        nop
        addiu   A0,A0,58
        MOVE    arg_z,A0
        MOVE    A0,arg_x                ; Get X position

        addiu   A0,A0,8                 ; X+=8 (For next char pos)
        MOVE    arg_x,A0

        CALL    ASM_FONT
        nop

        addiu   A0,A0,8
        MOVE    arg_x,A0                ; So it's automatickidoly stored

        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND
        PUSH    RA
        PUSH    A0

        mfc0    A0,Random               ;; Get Random Value!!!!!!!!
        MOVE    ret_1,A0                ;; Return Value in ret_1

        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND256
        PUSH    RA
        PUSH    A0
        PUSH    A1

        mfc0    A0,Random               ;; Get Random Value #1 0 - 31
        mfc0    A1,Random               ;; Get Random Value #2 0 - 31
        sll     A1,A1,5                 ;; multiply by 32
        add     A0,A0,A1                ;; A0 = A0+A1           gives 0 - 1023
        andi    A0,A0,$ff               ;; make value range between 0-255
        MOVE    ret_1,A0                ;; Return Value in ret_1

        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND128
        PUSH    RA
        PUSH    A0

        CALL    GET_RAND256
        MOVE    A0,ret_1                ;; bug
        andi    A0,A0,$7f               ;; 0 - 127
        MOVE    ret_1,A0                

        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND64k
        PUSH    RA
        PUSH    A0
        PUSH    A1

        CALL    GET_RAND256                     ;; Get High order
        MOVE    A0,ret_1                ;; bug
        sll     A0,A0,8
        CALL    GET_RAND256                     ;; Get Low order
        MOVE    A1,ret_1                ;; bug
        add     A0,A0,A1                ;; A0+=A1
        MOVE    ret_1,A0

        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    ASM_SPRITE16
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0
        push    T1
        push    T2
        push    T3
        push    T4

          
         MOVE    T0,arg_y       ;; bug
         MOVE    T1,arg_x       ;; bug
                 
         addiu    A0,T0,0               ; A0 = T0;
         addiu    A1,T0,0               ; A1 = T0   
         sll      A0,A0,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A0,A0,A1              ; A0+=A1 (A0 = (y<<8)+y<<6))
         add      A0,A0,T1                 
         add      A0,A0,T1               ; A0+=2*arg_x; (A0 = OFFSET)
        
         movea   T1,vscr0                ; points to page #0
         ;lui    T1,$8010
         ;ori    T1,T1,8

         add     T1,T1,A0                ; T1+=offset

        movea   A0,spr_dat           ; First sprite only
        movea   A1,game_pal          ; Points to 512 byte palette list

        MOVE    A2,arg_z             ; Gets the Sprite number
        sll     A2,A2,8                 ; A2*=256
        add     A0,A0,A2             ; spr_dat+=A2 (* pointer)

        addiu   T0,Rzero,16          ; Width of sprite
        addiu   A2,Rzero,0
SPR16newline:
        nop
        addiu   A3,Rzero,0              ; x = 0;
SPR16newpixel:
        nop
        lb      T2,$0(A0)               ; Get sprite pixel byte val T2 = *p;
                
        beq     T2,Rzero,SPR16skip      ; if(T2==0) goto SPR16skip;
        nop


        andi    T2,T2,$ff

        add     T3,A1,T2                ; T3 = game_pal+spr_byte
        add     T3,T3,T2                ; T3+= spr_byte
        
        ; Get RGB VAL
        lh      T4,$0(T3)               ; T2 = T3[0]

        ;addiu   T4,Rzero,C_XXX          ; We're testing THe RGB setup

        sh      T4,$0(T1)               ; *v = T4;

SPR16skip:
        nop
        addiu   T1,T1,2                 ; v++;  (* pointer) (16-bit)
        addiu   A0,A0,1                 ; p++;  (* pointer)
        addiu   A3,A3,1                 ; x++;   
        bne     A3,T0,SPR16newpixel     ; if(x!=16) goto SPR16newpixel;
        nop
        addiu   T1,T1,608               ; <CR> in sprite terms
        addiu   A2,A2,1                 ; y++;
        bne     A2,T0,SPR16newline      ; if(y!=16) goto SPR16newline;
        nop

        pop     T4
        pop     T3
        pop     T2
        pop     T1
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop

PROC    VIDEO_MODE
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0

        movea   A0,video_code   ; A0 points to start of video code
        lui     A1,$A440        ; A1 points to start of video regs
        addiu   A2,Rzero,0      ; counter
        addiu   A3,Rzero,13     ; 13 words (52 bytes (0x34)
        nop
VMloop:
        nop
        lw      T0,$0(A0)       ; T0 = p[0];
        sw      T0,$0(A1)       ; v[0]=T0;
        addiu   A0,A0,4         ; p++;  (WORD far *)
        addiu   A1,A1,4         ; v++;  (WORD far *)

        addiu   A2,A2,1         ; counter++;
        bne     A2,A3,VMloop    ; if(counter!=4) goto VMloop;
        nop
        nop

        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop

; ASM_PCX_VIEW:
;
; arg_x = x offset
; arg_y = y offset
; arg_z = start of .PCX image (address wise : PC+offset)
; arg_w = end of .PCX image (after last byte, address wise again)

PROC    ASM_PCX_VIEW
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0
        push    T1
        push    T2
        push    T3
        push    T4
        push    T5
        push    T6
        push    T7
              
        ; ------ Decode 24-bit palette and store it in game_pal (16-bit)

        addiu   T2,Rzero,256                    ;; 256 colors
        addiu   T3,Rzero,1                      ;; const-1

        move    T0,arg_w                ;; T0 points to end of pcx image
        addiu   T1,Rzero,768            ;; T1 = 768
        sub     T0,T0,T1                ;; T0-=768 (at the start of the palette)
        movea   T1,temp_pal             ;; T1 points to the temp_pal buffer
        nop
PCXV_pal:
        nop
        lb      A0,$0(T0)               ;; RED
        andi    A0,A0,$ff
        srl     A0,A0,3                 ;; divide by 8 to make it 0 - 31 (PCX is 0-255)
        sll     A0,A0,5                 ;; make space for GREEN

        lb      A1,$1(T0)               ;; GREEN
        andi    A1,A1,$ff
        srl     A1,A1,3                 ;; divide by 8 to make it 0 - 31 (PCX is 0-255)
        add     A0,A0,A1                ;; append it to RGB val
        sll     A0,A0,5                 ;; make space for BLUE

        lb      A1,$2(T0)               ;; BLUE
        andi    A1,A1,$ff
        srl     A1,A1,3                 ;; divide by 8 to make it 0 - 31 (PCX is 0-255)
        add     A0,A0,A1                ;; append it to RGB val
        sll     A0,A0,1                 ;; position bits so that its from 15-1

        sh      A0,$0(T1)               ;; Store 16bitRGB into game_pal

        addiu   T0,T0,3                 ;; move up to next color RGB val (PCX)
        addiu   T1,T1,2                 ;; move up the 16-bit style (N64)

        sub     T2,T2,T3                ;; T2--;

        bne     Rzero,T2,PCXV_pal       ;; if(T2) goto PCXV_pal;
        nop

        move    T6,arg_y                ;;
        move    T7,arg_x                ;;

        addiu    A0,T6,0               ; A0 = T6;
        addiu    A1,T6,0               ; A1 = T6   
        sll      A0,A0,9               ;  A0<<=9 512 / 256pix
        sll      A1,A1,7               ;  A0<<=7 128 / 64pix
        add      A0,A0,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
        movea   A1,vscr0                ; A1 points to our double buffer #0
        add     A0,A0,T7                ; A0 = A0+T7 (x) <-- Twice cos the
        add     A0,A0,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
        add     A0,A0,A1                ; A0+=A1
             

        move    A1,arg_z        ; A1 = arg_z;

        ; Get PCX-Length ----
        
        addiu   A1,A1,10
        lb      T6,$0(A1)       ; Get length in 1 byte range is 0 - 255 thats ok for now

        andi    T6,T6,$ff
        move    pcx_y,T6        ; pcx_y = Length

        addiu   A1,A1,118       ; Skip 128-byte header.

        movea   A2,temp_pal     ; A2 points to the start of the Temporary .pcx palette 16-bit

        addiu   T7,Rzero,0      ; Y counter
        addiu   T5,Rzero,1
        addiu   A3,Rzero,0      ; X counter
; ----------------------------------------------------------------------------
        nop
PCXV_np:
        nop
        lb      T2,$0(A1)       ; get run/color
        

        addiu   T6,T2,0         ; T6 = run/color
        andi    T6,T6,$c0       ; anded with last two bits 
        srl     T6,T6,6         ; Bring those two bits to the start (should be 3)
        addiu   T6,T6,1         ; add 1 (makes 4)
        andi    T6,T6,3         ; and it should be 0 for 192/over & 123 for below
                
        bne     T6,Rzero,PCXV_color  ; if less than 192 then do it as colors
        nop                     ; else...

        andi    T6,T2,$3f       ; T6 = T2&3f

        addiu   A1,A1,1         ; move up data by 1 byte to get the color
        lb      T2,$0(A1)       ; get color only!

        andi    T2,T2,$ff

        beq     Rzero,Rzero,PCXV_solid     ; if(*p) then draw it XXXXXXXXXXXX Change 1 Rzero to T2 & to 'bne'
        nop
        add     A3,A3,T6                ; x+=run-length
        add     A0,A0,T6                ;
        add     A0,A0,T6                ; v+=run-length*2
        addiu   A1,A1,1                 ; p++;
        beq     Rzero,Rzero,PCXV_doneseg
        nop

PCXV_solid:
        nop
        ; Convert Index to RGB
        add     T3,A2,T2                ; T3 = game_pal+spr_byte
        add     T3,T3,T2                ; T3+= spr_byte

        lh      T4,$0(T3)

        add   A3,A3,T6                ; X+=run-length

        nop
PCXV_run:
        nop

        sh      T4,$0(A0)               ; smash pulp to vid-buffer.
        addiu   A0,A0,2                 ; Move up by 1pixel/2bytes

        sub     T6,T6,T5                ; T6--;
        bne     T6,Rzero,PCXV_run       ; if(T6) goto PCXV_run;
        nop
        addiu   A1,A1,1                 ; Shift up run by 1
        beq     Rzero,Rzero,PCXV_doneseg            ; Finished doing seg
        nop

PCXV_color:                             ; Draw it as a Color Only.
        nop

        addiu   A3,A3,1                ; X++;
        ; Convert Index to RGB

        andi    T2,T2,$ff

        ;beq     Rzero,T2,PCXV_dontdraw  ; If(!*p) then don't draw it! XXXXX Derem this one
        nop

        add     T3,A2,T2                ; T3 = game_pal+spr_byte
        add     T3,T3,T2                ; T3+= spr_byte

        lh      T4,$0(T3)
        
        ; Write Pulp to video-buffer
        
        sh      T4,$0(A0)
        nop
PCXV_dontdraw:
        nop

        addiu   A0,A0,2                 ; Clock up by 1 pixel/2bytes
        addiu   A1,A1,1                 ; Move data up by a byte aswell
        nop
PCXV_doneseg:                           ; We've done a segment
        nop

        addiu   T0,Rzero,320            ; Width is 320
        bne     A3,T0,PCXV_np           ; if not equal to width then repeat
        nop
        addiu   A3,Rzero,0              ; X = 0;
        addiu   T7,T7,1                 ; y++;
        move    T0,pcx_y                ; T0 = pcx_y (length of pcx image)
        bne     T7,T0,PCXV_np           ; if not equal to length then repeat
        nop

PCXV_end:

        nop
        pop     T7
        pop     T6
        pop     T5        
        pop     T4
        pop     T3
        pop     T2
        pop     T1
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop


PROC    asm_show_vscr
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0

        movea   A0,vscr0                ; A0 points to the 320x240x65536 color buffer
        lui     A1,$8010
        addiu   A1,A1,8                 ; 0x8010:0008 Start Of video buffer
        addiu   A2,Rzero,19200          ; half the screen 19200*4 = 76.8k
        addiu   A2,A2,19200             ; other half of the screen 38400*4 = 153.6k
        ; We must do it twice as we cannot use values above 32767 (reason: signed values)
        addiu   T0,Rzero,1              ; T0 = 1 Constant
        nop
show_vscr_loop:
        nop

        lw      A3,$0(A0)               ; get that 32-bit value from double buffer
        sw      A3,$0(A1)               ; Blast that 32-bit value to video

        addiu   A0,A0,4                 ; p++; (word)
        addiu   A1,A1,4                 ; v++; (word)

        sub     A2,A2,T0                ; A2--;
        bne     Rzero,A2,show_vscr_loop
        nop
        
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop


PROC    asm_copy_vscr
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0
        
        move    A2,arg_z                 ; arg_z is source, NOT arg_x is dest

        bne     Rzero,A2,copy_vscr_x     ; (arg_x==1) goto copy_vscr_x;
        nop
        movea   A0,vscr0                 ; 1st page (source)
        movea   A1,vscr1                 ; 2nd page (dest)
        beq     Rzero,Rzero,copy_vscr_gotcha
        nop
copy_vscr_x:
        nop
        movea   A0,vscr1                 ; 2nd page (source)
        movea   A1,vscr0                 ; 1st page (dest)
        nop
copy_vscr_gotcha:
        nop

        ;lui     A1,$8010
        ;addiu   A1,A1,8                 ; 0x8010:0008 Start Of video buffer
        addiu   A2,Rzero,19200          ; half the screen 19200*4 = 76.8k
        addiu   A2,A2,19200             ; other half of the screen 38400*4 = 153.6k
        ; We must do it twice as we cannot use values above 32767 (reason: signed values)
        addiu   T0,Rzero,1              ; T0 = 1 Constant
        nop
copy_vscr_loop:
        nop

        lw      A3,$0(A0)               ; get that 32-bit value from double buffer
        sw      A3,$0(A1)               ; Blast that 32-bit value to video

        addiu   A0,A0,4                 ; p++; (word)
        addiu   A1,A1,4                 ; v++; (word)

        sub     A2,A2,T0                ; A2--;
        bne     Rzero,A2,copy_vscr_loop
        nop
        
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop



PROC    asm_clear_vscr
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0
        
        move    A2,arg_z                 ; arg_z is source, NOT arg_x is dest

        bne     Rzero,A2,clear_vscr_x     ; (arg_x==1) goto copy_vscr_x;
        nop
        movea   A0,vscr0                 ; 1st page (dest)
        beq     Rzero,Rzero,clear_vscr_gotcha
        nop
clear_vscr_x:
        nop
        movea   A0,vscr1                 ; 2nd page (dest)
        nop
clear_vscr_gotcha:
        nop

        ;lui     A1,$8010
        ;addiu   A1,A1,8                 ; 0x8010:0008 Start Of video buffer
        addiu   A2,Rzero,19200          ; half the screen 19200*4 = 76.8k
        addiu   A2,A2,19200             ; other half of the screen 38400*4 = 153.6k
        ; We must do it twice as we cannot use values above 32767 (reason: signed values)
        addiu   T0,Rzero,1              ; T0 = 1 Constant
        addiu   A3,Rzero,0              ; A3 = 0 (colour)
        nop
clear_vscr_loop:
        nop

        sw      A3,$0(A0)               ; Blast that 32-bit value to vscr

        addiu   A0,A0,4                 ; p++; (word)
        
        sub     A2,A2,T0                ; A2--;
        bne     Rzero,A2,clear_vscr_loop
        nop
        
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop


PROC    ASM_TEXT
        push    RA
        push    A0
        push    A1
        push    A2
        push    A3
        push    T0
        push    T1
        push    T2
        push    T3
        push    T4
        push    T5
        push    T6
        push    T7

        move    T5,arg_1                ; x shift
        move    T6,arg_2                ; y shift

        move    A0,arg_x                ; back up args.
        move    A1,arg_y                ;..
        move    A2,arg_c                ;...
        move    A3,arg_z                ;....

        move    T0,arg_w                ; T0 points to first letter
        addiu   T1,A0,0                 ; T1 = x
        addiu   T2,A1,0                 ; t2 = y
        move    T4,arg_3                ; 0 for no , 1 for yes (Background?)
        ;addiu   T4,Rzero,36             ; 36 = '$' (Terminator)
        ;addiu   T7,Rzero,35             ; 35 = '#' (New line)
        andi    T4,T4,$ff

        lb      T3,$0(T0)               ; T3 = p[0]; the character
        andi    T3,T3,$ff
        nop
TEXT_nc:
        nop
        move    arg_x,T1                ; x 
        move    arg_y,T2                ; y
        move    arg_z,T3                ; character

        beq     Rzero,T4,TEXT_nb        ; Background? (NO goto TEXT_nb)
        nop
        CALL    ASM_FONT
        nop
        beq     Rzero,Rzero,TEXT_cont   ; Continue once done
        nop
TEXT_nb:
        nop
        CALL    ASM_FONTNB
        nop
TEXT_cont:

        add   T1,T1,T5                 ; x+=arg_1;
        add   T2,T2,T6                 ; y+=arg_2;

        addiu   T0,T0,1                 ; move up
        lb      T3,$0(T0)               ; get value
        andi    T3,T3,$ff
        ;bne     T3,T7,TEXT_notnl        ; if(T3!='#') dont do this
        ;nop

        ;addiu   T0,T0,1                 ; skip the '#' and continue from there.
        ;lb      T3,$0(T0)               ; get new value
        ;addiu   T2,T2,8                 ; jump down a line
        ;addiu   T1,A0,0                 ; position T1 at the start of the line

        ;nop
;TEXT_notnl:
        nop
        bne     T3,Rzero,TEXT_nc           ; if(T3) goto TEXT_nc;
        nop

        

        move    arg_x,A0                ; Restore them.
        move    arg_y,A1                ;..
        move    arg_c,A2                ;...
        move    arg_z,A3                ;....

        pop     T7
        pop     T6
        pop     T5
        pop     T4
        pop     T3
        pop     T2
        pop     T1
        pop     T0
        pop     A3
        pop     A2
        pop     A1
        pop     A0
        pop     RA
        retf
        nop
        nop

PROC    PLAY_VOC
        push    RA
        push    T0
        push    T1
        push    A0

        movea   T0,voc_dat              ; T0 = voc_dat ( wave file )
        addiu   T1,Rzero,16000          ; T1 = 16000 its a bit bigger actually

        lui     A0,$A450                ; A0 = Audio Regs. (Addr Reg)
        sw      T0,$0(A0)               ; place address in addr reg.
        sw      T1,$4(A0)               ; place length in length reg.

        addiu   T0,Rzero,4000           ; 4000+1 = 4001 DAC RATE  (10Khz)
        addiu   T1,Rzero,7              ; BIT Rate is 7-bit. (3+1)*2 = 8
        sw      T0,$10(A0)              ; store DAC-rate
        sw      T1,$14(A0)              ; store BIT-rate
        ; Sample Rate = 45,500,000/DAC-RATE

        addiu   T0,Rzero,1              ; Switch Dma to Play. (1 = on,0 = off)
        sw      T0,$8(A0)               ; store DMA-switch.

        pop     A0
        pop     T1
        pop     T0
        pop     RA
        retf
        nop
        nop


PROC    PLAY_VOC2
        push    RA
        push    T0
        push    T1
        push    A0

        movea   T0,voc_dat             ; T0 = voc_dat ( wave file )
        addiu   T1,Rzero,16000          ; T1 = 16000 its a bit bigger actually

        lui     A0,$A450                ; A0 = Audio Regs. (Addr Reg)
        sw      T0,$0(A0)               ; place address in addr reg.
        sw      T1,$4(A0)               ; place length in length reg.

        ;addiu   T0,Rzero,4000           ; 4000+1 = 4001 DAC RATE  (10Khz)
        move    T0,voc_dac              ; Load dac rate.
        ;addiu   T1,Rzero,7              ; BIT Rate is 8-bit. (3+1)*2 = 8
        move    T1,voc_bit              ; Load bit rate.
        sw      T0,$10(A0)              ; store DAC-rate
        sw      T1,$14(A0)              ; store BIT-rate
        ; Sample Rate = 45,500,000/DAC-RATE

        addiu   T0,Rzero,1              ; Switch Dma to Play. (1 = on,0 = off)
        sw      T0,$8(A0)               ; store DMA-switch.

        pop     A0
        pop     T1
        pop     T0
        pop     RA
        retf
        nop
        nop



PROC    GET_VOC
        push    RA
        push    T0
        push    A0

        lui     A0,$A450                ; A0 = Audio Regs. (Addr Reg)
        lw      T0,$C(A0)               ; Get status Value (0x80000000 or 0x40..)

        srl     T0,T0,30                ; This will get the last two bits
        andi    T0,T0,3                 ; and it (so it will be (xx-binary)
        
        move    ret_1,T0                ; ret_1 = T0; (0 or 1)

        pop     A0
        pop     T0
        pop     RA
        retf
        nop
        nop


PROC    ERASE_VOC
        push    RA
        push    T0
        push    T1
        push    T2
        push    T3

        movea   T0,voc_dat              ; T0 points to voc data
        addiu   T2,Rzero,128            ; T2 = 0x80
        addiu   T1,Rzero,6000           ; T1 = 6000 bytes of data
        addiu   T3,Rzero,1              ; T3 = 1

        nop
EV_loop:
        nop
        sb      T2,$0(T0)               ; p[0] = 0x80;
        addiu   T0,T0,1                 ; T0++;
        sub     T1,T1,T3                ; T1--;

        bne     Rzero,T1,EV_loop
        nop

        pop     T3
        pop     T2
        pop     T1
        pop     T0
        pop     RA
        retf
        nop
        nop

PROC    GET_JOY
        push    RA
        push    A0
        push    T0
        push    T1
        push    T2


; 1st The most important thing is to tell the SI regs 0xa480:0000.. to make an update!!
        ; ok lets wait until last SI-dma transfer is complete
        lui     T0,$a480
        lw      T1,$18(T0)
        andi    T1,T1,$3                ; We only want bits 1-0
        bne     Rzero,T1,GJ_end         ; if(busy) return;
        nop
        ;-------------------------------------------------------
        ; - Ok so now the dma must be free to be used by us!!!!!

        ; 1) lets tell the SI where to deliver to....
        lui     T0,$a480
        lui     T1,$0                   ; RDRAM only 0000:0000 ->003f:0000 THIS IS CORRECT 100%
        sw      T1,$0(T0)               ; This area of mem definately gets the beats. 64 bytes of it aswell!
        
        ; 2) lets tell it where from (0x1fc0:07c0)
        lui     A0,$1fc0
        addiu   A0,A0,$7c0
        sw      A0,$4(T0)               ; PIF DMA write 64byte Request! PIF > RDRAM 4.5Meg!
        ; Okidoki All done.

; --------------------------------------------------------------------
        lui     A0,$1fc0
        addiu   A0,A0,$0              ; Joy status h-word

        lh      T0,$4(A0)               ; T0 = joystick values

; --------------------------------------------------------------------
        srl     T1,T0,8                 ; get high order byte of joy stats
        andi    T1,T1,$ff
        move    joy.byte1,T1            ; byte1 is stored


        andi    T1,T0,$ff              ; get low order byte of joy stats
        move    joy.byte2,T1            ; byte2 is stored
; --------------------------------------------------------------------

        addiu   T1,T0,0                 ; T1 = T0
        srl     T1,T1,8                 ;
        andi    T1,T1,$f                ; get U,D,L,R

        andi    T2,T1,1                 ; get bit #0 = R
        move    joy.right,T2

        srl     T1,T1,1
        andi    T2,T1,1                 ; get bit #0 = L
        move    joy.left,T2

        srl     T1,T1,1
        andi    T2,T1,1                 ; get bit #0 = D
        move    joy.down,T2

        srl     T1,T1,1
        andi    T2,T1,1                 ; get bit #0 = U
        move    joy.up,T2
        nop
GJ_end:
        nop
        pop     T2
        pop     T1
        pop     T0
        pop     A0
        pop     RA
        retf
        nop
        nop

; File system

.tag  "BLOCK64"
.file "BLOCK64" ;; Reserves a Chunk of data that will indefinately cover the registers location

.tag  "video_code"
.file "video.cod"

.tag  "img_dat"
.file "font.dat"

.tag  "game_pal"
.file "game.p16"

.tag  "temp_pal"        ; Temporary palette for .PCX 256 indexed images
.file "game.p16"

.tag  "spr_dat"
.file "mapsprs.psy"     ;; Sprites from ol' Psywar!!

.tag  "voc_dat"

.tag  "vscr0"
.file "VBLOCK" ;; Reserves 320x240 * 2 bytes for virtual screen #0
.tag  "vscr1"
.file "VBLOCK" ;; Reserves 320x240 * 2 bytes for virtual screen #1

.tag  "PCXIMGS"         ; PCXIMGS points to the start of the PCX image
.file "pcxa.pcx"
.tag  "PCXIMGE"         ; PCXIMGE points to the end of the PCX image

.byte "<-End->"
